#include <bits/stdc++.h>
using namespace std;

const long long MX=7e5+10;

vector < long long > ms[2*MX];
long long mas[2*MX],ch[2*MX],krb[2*MX];

map < pair < long long , long long > , long long > mp;

long long fget(long long a,long long b,long long c)
{
    return mp[make_pair(a,b)]+mp[make_pair(b,c)]+mp[make_pair(a,c)];
}

bool ccmp(long long a,long long b)
{
    return (ms[a].size()>ms[b].size());
}

void fun()
{
    mp.clear();

    vector < pair < long long , long long > > al;

    long long n;
    cin>>n;

    for(long long i=0;i<=2*n;i++)
    {
        mas[i]=0;
        ms[i].clear();
        ch[i]=0;
        krb[i]=0;
    }

    for(long long i=1;i<=n;i++)
    {
        long long a,b,c;
        cin>>a>>b>>c;

        if(a>b)
        {
            swap(a,b);
        }

        mp[make_pair(a,b)]=c;
        mp[make_pair(b,a)]=c;

        krb[a]++;
        krb[b]++;

        mas[a]+=c;
        mas[b]+=c;

        al.push_back({a,b});
    }

    for(auto [a,b]:al)
    {
        if(krb[a]>1 && krb[b]>1)
        {
            ms[a].push_back(b);
            ms[b].push_back(a);
        }
    }

    long long mx=0;
    for(long long i=1;i<=2*n;i++)
    {
        mx=max(mx,mas[i]);
    }

    vector < long long > por;
    for(long long i=1;i<=2*n;i++)
    {
        por.push_back(i);
    }
    sort(por.begin(),por.end(),ccmp);

    map < pair < long long , long long > , long long > havealr;

    for(auto a:por)
    {
        for(auto b:ms[a])
        {
            ch[b]=1;
        }

        for(auto b:ms[a])
        {
            if(havealr[make_pair(a,b)])
            {
                continue;
            }

            havealr[make_pair(a,b)]=1;
            havealr[make_pair(b,a)]=1;

            for(auto c:ms[b])
            {
                if(ch[c] && c!=a)
                {
                    mx=max(mx,fget(a,b,c));
                }
            }
        }

        for(auto b:ms[a])
        {
            ch[b]=0;
        }
    }

    cout<<mx<<"\n";
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    long long t;
    cin>>t;

    while(t--)
    {
        fun();
    }

    return 0;
}
